(function (wd, dc) {
// HANDLING STEPS 1 & 2 FUNCTIONALITY  ------------------------------------------------------------
    const step1Section = document.getElementById('nwpcb-step-1');
    const step2Section = document.getElementById('nwpcb-step-2');
    const progressIndicator = document.getElementById('nwpcb-progress');
    const backButton = document.getElementById('nwpcb-back-step');
    const backButtonIcon = document.getElementById('nwpcb-back-button');
    const title1 = document.getElementById('nwpcb-title-1');
    const title2 = document.getElementById('nwpcb-title-2');
    const nextButton = document.getElementById('nwpcb-next');
    const finishButton = document.getElementById('nwpcb-finish');
    const logo = document.getElementById('nwpcb-logo');
    window.jims_services = [];


    const form = document.querySelector('#the-form');

    const url = new URL(window.location);

    if (!window.hasOwnProperty('jims_wpcb_variables')) return;

    const stepNumber = parseInt(window.location.hash.replace('#nwpcb-step-', ''), 10);
    switchToStep(stepNumber === 2 ? 2 : 1);

    let divisionID = 1;
    if (window.jims_wpcb_variables) {
        divisionID = window.jims_wpcb_variables.DivisionId;
    }

    fetch(`${window.jims_wpcb_variables.home_url}/wp-json/jims-wpcb/v1/service/division/services?division_id=${divisionID}`, {
        method: 'GET',
        headers: {
            'Content-Type': 'application/json',
            'Accept': 'application/json'
        }
    }).then(response => {
        return response.json();
    }).then(response => {
        window.jims_services = Object.values(response);
        generateServicesList(window.jims_services);
    }).catch(error => {
        console.log(error);
    });


    function switchToStep(stepNumber, evt = false) {
        if (evt) {
            evt.preventDefault();
        }
        if (stepNumber === 1) {
            step1Section.classList.add('open');
            step2Section.classList.remove('open');
            progressIndicator.classList.add('step-1');
            progressIndicator.classList.remove('step-2');
            backButtonIcon.classList.remove('visible');
            title1.classList.add('visible');
            title2.classList.remove('visible');
            nextButton.classList.add('visible');
            finishButton.classList.remove('visible');
            logo.classList.remove('step-2');

        } else if (stepNumber === 2) {

            const checkboxes = document.querySelectorAll('input[type=checkbox]:checked');
            if (checkboxes.length === 0) {
                alert('Please select at least one service.');
                return;
            }

            step1Section.classList.remove('open');
            step2Section.classList.add('open');
            progressIndicator.classList.remove('step-1');
            progressIndicator.classList.add('step-2');
            backButtonIcon.classList.add('visible');
            title1.classList.remove('visible');
            title2.classList.add('visible');
            nextButton.classList.remove('visible');
            finishButton.classList.add('visible');
            logo.classList.add('step-2');


            const selectedServicesContainer = document.querySelector('.nwpcb-selected-services ul');
            selectedServicesContainer.innerHTML = '';
            checkboxes.forEach((checkbox) => {
                const serviceName = checkbox.parentNode.querySelector('.label-text').textContent.trim();

                const li = document.createElement('li');

                const checkmark = document.createElement('span');
                checkmark.className = 'checkmark';
                checkmark.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="26" height="26" viewBox="0 0 26 26"><path d="M 22.566406 4.730469 L 20.773438 3.511719 C 20.277344 3.175781 19.597656 3.304688 19.265625 3.796875 L 10.476563 16.757813 L 6.4375 12.71875 C 6.015625 12.296875 5.328125 12.296875 4.90625 12.71875 L 3.371094 14.253906 C 2.949219 14.675781 2.949219 15.363281 3.371094 15.789063 L 9.582031 22 C 9.929688 22.347656 10.476563 22.613281 10.96875 22.613281 C 11.460938 22.613281 11.957031 22.304688 12.277344 21.839844 L 22.855469 6.234375 C 23.191406 5.742188 23.0625 5.066406 22.566406 4.730469 Z"></path></svg>';


                const serviceNameEl = document.createElement('span');
                serviceNameEl.textContent = serviceName;

                li.appendChild(checkmark);
                li.appendChild(serviceNameEl);

                selectedServicesContainer.appendChild(li);
            });
        }

        window.location.hash = `nwpcb-step-${stepNumber}`;
    }


// HANDLING  SERVICES --------------------------------------------------------------------------------------------------------------------------------------------


    function generateServicesList(data) {
        const container = document.getElementById("nwpcb-results");
        container.innerHTML = "";

        const serviceList = document.createElement("ul");
        serviceList.classList.add("nwpcb-ul");

        for (const service of data) {
            const listItem = document.createElement("li");

            const checkboxLabel = document.createElement("label");
            checkboxLabel.classList.add("nwpcb-checkbox");

            const checkbox = document.createElement("input");
            checkbox.type = "checkbox";
            // checkbox.name = "service";
            checkbox.id = `service-${service.id}`;
            checkbox.value = service.id;
            checkboxLabel.appendChild(checkbox);

            const labelText = document.createElement("span");
            labelText.classList.add("label-text");
            labelText.textContent = service.name.replace('HANDY ', '');

            const checkmark = document.createElement("span");
            checkmark.classList.add("checkmark");
            checkmark.innerHTML = `<svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="26" height="26" viewBox="0 0 26 26"> <path d="M 22.566406 4.730469 L 20.773438 3.511719 C 20.277344 3.175781 19.597656 3.304688 19.265625 3.796875 L 10.476563 16.757813 L 6.4375 12.71875 C 6.015625 12.296875 5.328125 12.296875 4.90625 12.71875 L 3.371094 14.253906 C 2.949219 14.675781 2.949219 15.363281 3.371094 15.789063 L 9.582031 22 C 9.929688 22.347656 10.476563 22.613281 10.96875 22.613281 C 11.460938 22.613281 11.957031 22.304688 12.277344 21.839844 L 22.855469 6.234375 C 23.191406 5.742188 23.0625 5.066406 22.566406 4.730469 Z"></path></svg>`
            labelText.appendChild(checkmark);

            checkboxLabel.appendChild(labelText);

            listItem.appendChild(checkboxLabel);
            serviceList.appendChild(listItem);
        }

        container.appendChild(serviceList);


        // Get all checkboxes
        const checkboxesInit = document.querySelectorAll('input[type=checkbox]');

        // Get the submit button

        // Add an event listener to each checkbox
        checkboxesInit.forEach(checkbox => {
            checkbox.addEventListener('change', function () {
                // Check if at least one checkbox is checked
                const isChecked = Array.from(checkboxesInit).some(cb => cb.checked);

                // Enable or disable the submit button depending on whether a checkbox is checked
                if (!isChecked) {
                    nextButton.classList.add('disabled');
                } else {
                    nextButton.classList.remove('disabled');
                }

            });
        });

    }

//Search filter function
    function filterServicesList(query) {
        const filteredData = window.jims_services.filter((service) =>
            service.name.toLowerCase().includes(query.toLowerCase())
        );

        if (filteredData.length === 0) {
            const container = document.getElementById("nwpcb-results");
            container.innerHTML = "<p>No Results</p>";
        } else {
            generateServicesList(filteredData);
        }
    }

// Event listener for search field
    const searchBar = document.getElementById("search-bar");
    searchBar.addEventListener("input", (event) => {
        const query = event.target.value;
        filterServicesList(query);
    });


// HANDLING INFORMATION AND FORMS --------------------------------------------------------------------------------------------------------------------------------------------


    function updateCountryIcon() {
        // Get the value of the selected option
        const country = document.getElementById("country").value;

        // Update the country icon
        const icon = document.getElementById("nwpcb-country-icon");
        icon.innerHTML = `<img src="${window.jims_wpcb_variables.wpcb_url}assets/img/${country}.png" alt="${country} flag" />`;

    }

    updateCountryIcon();

//GET THE SELECTED SERVICES
    const selectedServices = [];

    function getNextSelectedServices() {
        const selectedCheckboxes = document.querySelectorAll('input[type="checkbox"]:checked');
        selectedServices.length = 0; // clear previous selection
        selectedCheckboxes.forEach((checkbox) => {
            selectedServices.push(checkbox.value);
        });
    }

    nextButton.addEventListener('click', getNextSelectedServices);


    function formDataToJSON(formData) {
        const object = {};
        formData.forEach((value, key) => {
            object[key] = value
        });
        return JSON.stringify(object);
    }

    finishButton.addEventListener('click', submitRequest)

    /**
     * @param {Event} evt
     * @returns {boolean}
     */
    function submitRequest(evt) {
        evt.preventDefault();

        return false;
    }


    async function sendData(url, data) {
        return await fetch(url, {
            method: 'POST',
            body: data,
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
            }
        })
            .then(response => response.json())
            .catch(error => console.error(error))
    }

    /**
     * @param {FormData} form
     */
    function validateForm(form) {
        //interate through form data and check if any field is empty and email is valid, message and bussiness name are optional
        let errors = [];
        for (let [key, value] of form.entries()) {
            if (key === 'message' || key === 'business_name') continue;

            if (key === 'email' && !isValidEmail(value)) {
                errors.push('Please enter a valid email address');
            } else if (key === 'phone' && !isValidPhoneNumber(value)) {
                errors.push('Please enter a valid phone number');
            } else if (value === '') {
                errors.push(`Please fill ${key} field`);
            }
        }

        //show errors
        if (errors.length > 0) {
            const errorContainer = document.querySelector('#nwpcb-errors ul');
            errorContainer.innerHTML = `<li>${errors.join('</li><li>')}</li>`;
        }

        return errors.length === 0;
    }


    function isValidEmail(email) {
        // A simple regex pattern to validate email addresses
        const emailPattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return emailPattern.test(email);
    }

    function isValidPhoneNumber(phoneNumber) {
        // A simple regex pattern to validate phone numbers
        const phoneNumberPattern = /^[\d\s()+-]+$/;
        return phoneNumberPattern.test(phoneNumber);
    }

    function prDefault(evt) {
        evt.preventDefault();
    }

    window.switchToStep = switchToStep;
}(window, document));