<?php

namespace JimsCustomerBooking\Admin\BackendPages;

use JimsCustomerBooking\Helpers\OptionHelper;
use JimsCustomerBooking\Helpers\SettingsHelper;
use JimsCustomerBooking\Helpers\StringHelper;
use JimsCustomerBooking\Jims_Options;

if( ! class_exists('JimsCustomerBooking\Admin\BackendPages\ShortCodeGeneratorPage')){
    class ShortCodeGeneratorPage extends BackendPage {

        use SettingsTrait;

        /**
         * @var string
         */
        protected $name = 'Shortcode Generator';

        protected $parent_slug = 'wpcb_settings.php';
        /**
         * @var string
         */
        protected $menu_slug = 'cb_shortcode_generator.php';

        /**
         * @var string
         */
        protected $template_name = 'shortcode.generator';

        protected $hide_menu_item = true;

        public function GetContent()
        {
            /**
             * @var Jims_Options $options
             */
            $options = OptionHelper::get('form', new Jims_Options());
            if( !($options instanceof Jims_Options) ){
                $options = unserialize($options);
            }


            ($this->GetTemplate())->render([
                'title' => 'Shortcode Generator',
                'fields' => $options->getProperties(),
                'native_fields' => OptionHelper::get(NativeFormSettingsPage::$option_name, []),
                'jims_options' => $options,
                'pages' => SettingsHelper::getSettingsPages (),
                'services' => (new \JimsCustomerBooking\Services\DivisionService())->getServices(true),
                'css_class' => StringHelper::GetPrefixed('wrapper'),
                'parts' => $this->GetParts ()
            ]);
        }

        function make_request($url, $json_decode = true, $additional_headers = []){
            $curl = curl_init();
            curl_setopt_array($curl, array_merge( array(
                CURLOPT_RETURNTRANSFER => 1,
                CURLOPT_CONNECTTIMEOUT => 0, //timeout
                CURLOPT_TIMEOUT => 1, //timeout
                CURLOPT_URL => $url,
                CURLOPT_HTTPHEADER => [
                    'User-Agent: keycdn-tools:https://jims.net'
                ],
            ), $additional_headers));
            $output = curl_exec($curl);
            curl_close($curl);

            return $json_decode ? json_decode($output, TRUE) : $output;
        }
    }
}