<?php

namespace JimsCustomerBooking\Helpers;

use JimsCustomerBooking\Admin\BackendPages\NativeFormSettingsPage;
use JimsCustomerBooking\Jims_Plugin;

if( ! class_exists('JimsCustomerBooking\Helpers\OptionHelper')){
    /**
     *
     */
    class OptionHelper extends Helper {

        /**
         * @param $option_name
         * @param $default
         * @return false|mixed|void
         */
        public static function get($option_name, $default = null){
            return get_option( StringHelper::GetPrefixed($option_name, 'machine'), $default );
        }

        public static function getValue($option_name, $value_name, $default = null){
            $option = self::get($option_name, []);
            return $option[$value_name] ?? $default;
        }

        /**
         * @param $script_name
         * @return void
         */
        public static function localizeFormVariables($script_name){
            wp_localize_script(
                StringHelper::GetPrefixed($script_name),
                StringHelper::GetPrefixed('variables', 'machine'),
                array_merge(
                    [
                        'home_url' => get_bloginfo('wpurl'),
                        'wpcb_url' => JIMS_CBP_URL,
                        'rest_url' => get_rest_url (),
                        'secret' => wp_create_nonce('wp_rest'),
                    ],
                    static::get(NativeFormSettingsPage::$option_name, []),
                    ['embeddedFormOptions' => Jims_Plugin::getOptions()->getProperties()],
                )
            );
        }
    }
}