<?php

namespace JimsCustomerBooking\RestfulAPI;

use JimsCustomerBooking\Services\DivisionService;

if( ! class_exists('JimsCustomerBooking\RestfulPI\ServiceController')){
    class ServiceController extends RestController {

        /**
         * @var string
         */
        protected $route = 'service';


        public function register_routes(){
            register_rest_route($this->get_namespace(), $this->get_route() . '/division', [
                [
                    'methods' => \WP_REST_Server::READABLE,
                    'callback' => array($this, 'get_divisions'),
                    'permission_callback' => '__return_true',
                ]
            ]);

            register_rest_route($this->get_namespace(), $this->get_route() . '/division/services', [
                [
                    'methods' => \WP_REST_Server::READABLE,
                    'callback' => array($this, 'get_services'),
                    'permission_callback' => '__return_true',
                ]
            ]);

            register_rest_route ($this->get_namespace (), $this->get_route () . '/countries', [
                [
                    'methods' => \WP_REST_Server::READABLE,
                    'callback' => array($this, 'get_countries'),
                    'permission_callback' => '__return_true',
                ]
            ]);
        }

        /**
         * @param $request
         * @return \WP_REST_Response
         */
        public function get_divisions($request){
            $service = new DivisionService();
            return $this->response($service->getDivisions());
        }

        /**
         * @param \WP_REST_Request $request
         * @return \WP_REST_Response
         */
        public function get_services($request){
            $service = new DivisionService();
            $payload = $service->getServices()->payload->jimsServices;

            if( $request->has_param('division_id') && (int) $request->get_param('division_id') > 0 ){

                $filtered = array_filter($payload, function($service) use ($request){
                    return $service->group_id == $request->get_param('division_id');
                });
                return $this->response($filtered);
            }

            return $this->response($service->getServices()->payload->jimsServices);
        }

        /**
         * @param $request
         * @return \WP_REST_Response
         */
        public function get_countries($request){
            $service = new DivisionService();
            return $this->response($service->getCountries());
        }

    }
}